/********************************** (C) COPYRIGHT *******************************
* File Name          : ch32v30x_it.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : Main Interrupt Service Routines.
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/
#include "ch32v20x_it.h"
#include "FreeRTOS.h"
#include "wchnet.h"
#include "eth_driver.h"
void NMI_Handler(void) __attribute__((interrupt()));
void HardFault_Handler(void) __attribute__((interrupt()));
void ETH_IRQHandler(void) __attribute__((interrupt()));
void EXTI9_5_IRQHandler(void) __attribute__((interrupt()));
/*********************************************************************
 * @fn      NMI_Handler
 *
 * @brief   This function handles NMI exception.
 *
 * @return  none
 */
void NMI_Handler(void)
{

}

/*********************************************************************
 * @fn      HardFault_Handler
 *
 * @brief   This function handles Hard Fault exception.
 *
 * @return  none
 */
void HardFault_Handler(void)
{
    printf("HardFault_Handler\r\n");
    printf("mcause:%08x\r\n",__get_MCAUSE());
    printf("mtval:%08x\r\n",__get_MTVAL());
    printf("mepc:%08x\r\n",__get_MEPC());
    while (1);
}
/*********************************************************************
 * @fn      ETH_IRQHandler
 *
 * @brief   This function handles ETH exception.
 *
 * @return  none
 */
void ETH_IRQHandler(void)
{
    GET_INT_SP();
    portDISABLE_INTERRUPTS();
    WCHNET_ETHIsr();
    portENABLE_INTERRUPTS();
    FREE_INT_SP();
}
void EXTI9_5_IRQHandler(void)
{
    // ETH_PHYLink( );
    GET_INT_SP();
    portDISABLE_INTERRUPTS();
    EXTI_ClearITPendingBit(EXTI_Line7);     /* Clear Flag */
    portENABLE_INTERRUPTS();
    FREE_INT_SP();
}
